#region Copyright
/*
 * Copyright 2005-2008 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
#endregion

using System;
using System.Collections;

namespace Seasar.Framework.Aop.Interceptors
{
    /// <summary>
    /// Intercept̑ΏۂƂȂ郁\bhƃCX^XMockɂ܂
    /// </summary>
    public class MockInterceptor : AbstractInterceptor
    {
        /// <summary>
        /// Mock̖߂l
        /// </summary>
        private readonly Hashtable _returnValues = new Hashtable();

        /// <summary>
        /// Mock̗O
        /// </summary>
        private readonly Hashtable _exceptions = new Hashtable();

        /// <summary>
        /// \bhĂяoς݂ǂtO
        /// </summary>
        private readonly Hashtable _invokedMethods = new Hashtable();

        /// <summary>
        /// \bhĂяoƂ̈
        /// </summary>
        private readonly Hashtable _invokedMethodArgs = new Hashtable();

        /// <summary>
        /// RXgN^
        /// </summary>
        public MockInterceptor()
        {
        }

        #region IMethodInterceptor NX

        /// <summary>
        /// \bhInterceptꍇÃ\bhĂяo܂
        /// </summary>
        /// <param name="invocation">IMethodInvocation</param>
        /// <returns>Intercept郁\bh̖߂l</returns>
        public override object Invoke(IMethodInvocation invocation)
        {
            string methodName = invocation.Method.Name;
            _invokedMethods[methodName] = true;
            _invokedMethodArgs[methodName] = invocation.Arguments;

            if (_exceptions.ContainsKey(methodName))
            {
                throw (Exception) _exceptions[methodName];
            }
            else if (_exceptions.ContainsKey(string.Empty))
            {
                throw (Exception) _exceptions[string.Empty];
            }
            else if (_returnValues.ContainsKey(methodName))
            {
                return _returnValues[methodName];
            }
            else
            {
                return _returnValues[string.Empty];
            }
        }

        #endregion

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="value">Mock̖߂l</param>
        public MockInterceptor(object value)
        {
            SetReturnValue(value);
        }

        /// <summary>
        /// ߂l̐ݒ
        /// </summary>
        /// <remarks>
        /// Mockׂ̂Ẵ\bh̖߂lݒ肵܂B
        /// </remarks>
        /// <param name="returnValue">߂l</param>
        public void SetReturnValue(object returnValue)
        {
            SetReturnValue(string.Empty, returnValue);
        }

        /// <summary>
        /// ߂l̐ݒ
        /// </summary>
        /// <remarks>
        /// Mock̎w肳ꂽÕ\bh̖߂lݒ肵܂B
        /// </remarks>
        /// <param name="methodName">߂lݒ肷郁\bh</param>
        /// <param name="returnValue">߂l</param>
        public void SetReturnValue(string methodName, object returnValue)
        {
            _returnValues[methodName] = returnValue;
        }

        /// <summary>
        /// O̐ݒ
        /// </summary>
        /// <remarks>
        /// Mockׂ̂Ẵ\bhɗOݒ肵܂B
        /// </remarks>
        /// <param name="exception">O</param>
        public void SetThrowable(Exception exception)
        {
            SetThrowable(string.Empty, exception);
        }

        /// <summary>
        /// O̐ݒ
        /// </summary>
        /// <remarks>
        /// Mockׂ̂Ẵ\bhɗOݒ肵܂B
        /// </remarks>
        /// <param name="methodName">Oݒ肷郁\bh</param>
        /// <param name="exception">O</param>
        public void SetThrowable(string methodName, Exception exception)
        {
            _exceptions[methodName] = exception;
        }

        /// <summary>
        /// Mock̃\bhɌĂяoĂ邩肵܂
        /// </summary>
        /// <param name="methodName">ĂяoĂ邩ǂ肷郁\bh</param>
        /// <returns>Mock̃\bhɌĂяoĂ邩</returns>
        public bool IsInvoked(string methodName)
        {
            return _invokedMethods.ContainsKey(methodName);
        }

        /// <summary>
        /// Mock̃\bhĂ΂ꂽƂ̈擾܂
        /// </summary>
        /// <param name="methodName">擾郁\bh</param>
        /// <returns>̃Xg</returns>
        public object[] GetArgs(string methodName)
        {
            return (object[]) _invokedMethodArgs[methodName];
        }
    }
}
